% logist5.m
% Matlab file for Part 5 of the Logistic Growth module

disp('********************************************')
disp('Part 5:  Fitting a Logistic Model to Data, I')
disp('********************************************')
disp('  ')    

    format short

    disp('Step 1:')
    disp('Here is the data for the U.S. population ')
    disp('levels in millions from 1790 to 1940: ')
    time=[1790,1800,1810,1820,1830,1840,1850,1860,...')
          1870,1880,1890,1900,1910,1920,1930,1940]
    pop=[3.929, 5.308, 7.240, 9.638, 12.866, 17.069,...')
         23.192, 31.443, 38.558, 50.156, 62.948,...')
         75.996, 91.972, 105.711, 122.775, 131.669]
    disp(' ')
    disp('--------------------------------------------')
    disp('Entering the following commands will compute')
    disp('symmetric difference quotients to approximate')
    disp('the slope of the population curve at various')
    disp('times.  ')
    disp(' ')
    disp('Enter:')
    disp(' ')
    disp('  n=size(pop,2); ');
    disp('  for i=2:n-1 ')
    disp('    popdiff=pop(i+1)-pop(i-1); ')
    disp('    timediff=time(i+1)-time(i-1); ')
    disp('    slope(i)=popdiff/timediff; ')
    disp('  end ')
    disp(' ')
    disp('To continue afterwards, type the word return')
    disp('and hit enter!')
    disp(' ')
    
    keyboard;
    disp(' ')

    disp('--------------------------------------------')
    disp('Step 1 (cont.): ')
    disp('The slope estimates only exist for the years ')
    disp('1800 to 1930.  For those years, we compute') 
    disp('the ratios of slope to population and make')
    disp('a scatter plot of these ratios.')
    disp(' ')
    disp('Enter:')
    disp(' ')
    disp(' s_slope=slope(2:n-1); ')
    disp(' s_pop=pop(2:n-1); ')
    disp(' ratios=s_slope./s_pop;')
    disp(' clf ')
    disp(' plot(s_pop,ratios,''bo'') ')
    disp(' ')
    disp('To continue afterwards, type the word return')
    disp('and hit enter!')
    disp(' ')
    
    keyboard;
    disp(' ')

    disp('--------------------------------------------')
    disp('Step 2 and 3: ')
    disp('Estimate the slope m and the y-intercept b ')
    disp('of a line that fits the ratios plot and')
    disp('enter them below.  Note that r and K follow')
    disp('from m and b.')
    disp(' ')
    disp('Enter: ')
    disp(' ')
    disp('   m = ? ')
    disp('   b = ? ')
    disp('   r = b ')
    disp('   K = -r/m ')
    disp(' ')
    disp('To continue afterwards, type the word return')
    disp('and hit enter!')
    disp(' ')
    
    keyboard;
    disp(' ')

    disp('--------------------------------------------')
    disp('Step 4: ')
    disp('Enter your values of r and K from above')
    disp('and plot the curve f = r*(1-P/K) on top')
    disp('of the ratios scatter plot.')
    disp(' ')
    disp('Adjust r and K to get the best fit and replot.')
    disp(' ')
    disp('Enter: ')
    disp(' ')
    disp('  r = ? ') 
    disp('  K = ? ')
    disp('  Pvals=0: 2: 140;  ')
    disp('  y = r*(1-Pvals/K); ')
    disp('  clf ')
    disp('  plot(Pvals,y,''r'') ')
    disp('  hold on ')
    disp('  plot(s_pop,ratios,''bo'') ')
    disp(' ')

    disp('To continue afterwards, type the word return')
    disp('and hit enter!')
    disp(' ')
    
    keyboard;
    disp(' ')

    disp('--------------------------------------------')
    disp('Step 5:')
    disp('Interpret your final parameter values.  Answer')
    disp('the questions using MATLAB comments in your')
    disp('diary file.')
    disp(' ')
    disp('To continue afterwards, type the word return')
    disp('and hit enter!')
    disp(' ')
    
    keyboard;
    disp(' ')

    disp('--------------------------------------------')
    disp('Step 6:')
    ext_time=[time,1950,1960, 1970, 1980, 1990];
    ext_pop=[pop,150.697, 179.323, 203.185, 226.546, 248.710];
    disp('We have added the years 1950 to 1990 (in ten')
    disp('year intervals) to the time array and the ')
    disp('corresponding U.S. populations to the pop array.')
    disp('The new arrays are called ext_time and ext_pop.')
    disp(' ')
    disp('Now we comute the ratios of the slopes dP/dt to')
    disp('the populations P and plot the ratios versus')
    disp('the populations. ')
    disp(' ')
    disp('Enter: ')
    disp(' ')
    disp('  n=size(ext_pop,2); ');
    disp('  for i=2:n-1 ')
    disp('    popdiff=ext_pop(i+1)-ext_pop(i-1); ')
    disp('    timediff=ext_time(i+1)-ext_time(i-1); ')
    disp('    slope(i)=popdiff/timediff; ')
    disp('  end ')
    disp('  s_epop=ext_pop(2:n-1); ')
    disp('  ratios=slope(2:n-1)./s_epop;')
    disp('  clf ')
    disp('  plot(s_epop,ratios,''bo'') ')
    disp(' ')
    disp('---------------------------------------------')
    disp('Why does the plot tell you that a logistic model')
    disp('for this data would not be reasonable? ')
    disp('Explain using MATLAB comments in your diary file.')
    disp(' ')
    disp(' ')
    disp('--------------------------------------------')
    disp('To go on to Part 6 of this module,')
    disp('type: logist6.')
    disp(' ')

     